<?php

namespace App\Controller;

use App\Entity\Fault;
use App\Form\FaultType;
use App\Repository\FaultRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
class FaultController extends AbstractController
{
    public function __construct(
        private readonly EntityManagerInterface $entityManager,
        private readonly FaultRepository $faultRepository
    )
    {
    }
    #[Route('/fault/add', name: 'fault_add')]
    public function add(Request $request): Response
    {
        $fault = new Fault();
        $form = $this->createForm(FaultType::class, $fault);
        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid())
        {
            $this->entityManager->persist($fault);
            $this->entityManager->flush();

            return $this->redirectToRoute("fault_list");
        }

        return $this->render('fault/add.html.twig', [
            'form' => $form,
        ]);
    }

    #[Route('/fault/list', name: 'fault_list')]
    public function list(): Response
    {
        $faults = $this->faultRepository->findAll();

        return $this->render('fault/list.html.twig', [
            'faults' => $faults,
        ]);
    }
}