<?php

namespace App\Controller;

use App\Entity\Intervention;
use App\Form\InterventionType;
use App\Repository\InterventionRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class InterventionController extends AbstractController
{
    public function __construct(
        private readonly EntityManagerInterface $entityManager,
        private readonly InterventionRepository $interventionRepository
    )
    {
    }
    #[Route('/intervention/add', name: 'intervention_add')]
    public function add(Request $request): Response
    {
        $intervention = new Intervention();
        $form = $this->createForm(InterventionType::class, $intervention);
        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid())
        {
            $this->entityManager->persist($intervention);
            $this->entityManager->flush();

            return $this->redirectToRoute("intervention_list");
        }

        return $this->render('intervention/add.html.twig', [
            'form' => $form,
        ]);
    }

    #[Route('/intervention/list', name: 'intervention_list')]
    public function list(): Response
    {
        $interventions = $this->interventionRepository->findAll();

        return $this->render('intervention/list.html.twig', [
            'interventions' => $interventions,
        ]);
    }
}